<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.18"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>XHXKit: XHXKit/Classes/BeginnerTipsManager/BeginnerTipsManager.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &#160;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.18 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_beginner_tips_manager_8m_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">BeginnerTipsManager.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_beginner_tips_manager_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">//  BeginnerTipsManager.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">//  XHXKit</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">//  Created by guohua on 2020/3/30.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#import &quot;<a class="code" href="_beginner_tips_manager_8h.html">BeginnerTipsManager.h</a>&quot;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#import &quot;<a class="code" href="_beginner_tips_view_8h.html">BeginnerTipsView.h</a>&quot;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#import &quot;<a class="code" href="_u_i_color_09_hex_8h.html">UIColor+Hex.h</a>&quot;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno"><a class="line" href="category_beginner_tips_manager_07_08.html">   11</a></span>&#160;<span class="keyword">@interface </span><a class="code" href="interface_beginner_tips_manager.html">BeginnerTipsManager</a> ()</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div>
<div class="line"><a name="l00013"></a><span class="lineno"><a class="line" href="category_beginner_tips_manager_07_08.html#a9ec18d2dfede37f31137e425dae5f74e">   13</a></span>&#160;<span class="keyword">@property</span> (nonatomic, strong) <a class="code" href="interface_beginner_tips_view.html">BeginnerTipsView</a>  *tipView;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div>
<div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="category_beginner_tips_manager_07_08.html#a1105fcb6b7a71fad9ce09a1d3cf4e58d">   15</a></span>&#160;<span class="keyword">@property</span> (nonatomic, strong) UITapGestureRecognizer  *tapGesture;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="category_beginner_tips_manager_07_08.html#a6730cd45c07499dc59f87db695596b22">   17</a></span>&#160;<span class="keyword">@property</span> (nonatomic, strong) UIWindow  *tipWindow;</div>
<div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="category_beginner_tips_manager_07_08.html#ae7767e534f2faa25651e53dc62f8a6e0">   18</a></span>&#160;<span class="keyword">@property</span> (nonatomic, strong) UIView  *bgView;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="category_beginner_tips_manager_07_08.html#a751af8916ffe0896402963aaef1843b3">   20</a></span>&#160;<span class="keyword">@property</span> (nonatomic, strong) UIView  *invertedTriangleView;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="category_beginner_tips_manager_07_08.html#a5059cc142d295a2040af5d953c90899e">   22</a></span>&#160;<span class="keyword">@property</span> (nonatomic,assign) TriangleDirectionType triangleDirectionType;</div>
<div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="interface_beginner_tips_manager.html#a85340e58bc5fddbef3ed5f3898452eae">   23</a></span>&#160;<span class="keyword">@property</span> (nonatomic,assign) CGRect dotReact;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">@end</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">@implementation </span><a class="code" href="interface_beginner_tips_manager.html">BeginnerTipsManager</a></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;+ (BOOL)tipWindowHasShowForKey:(NSString *)key {</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    BOOL isShowed = [[NSUserDefaults standardUserDefaults] boolForKey:key];</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keywordflow">return</span> isShowed;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;}</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;+ (void)updateTipWindowHasShowForKey:(NSString *)key {</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    [[NSUserDefaults standardUserDefaults] setBool:YES forKey:key];</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    [[NSUserDefaults standardUserDefaults] synchronize];</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;}</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;-(void)showTipViewWithTip:(NSString *)tip directionType:(TriangleDirectionType)type dotReact:(CGRect)dotReact emptyReact:(CGRect)emptyReact</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;{</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    _triangleDirectionType = type;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    _dotReact = dotReact;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    [<span class="keyword">self</span>.tipWindow addSubview:self.bgView];</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    [<span class="keyword">self</span>.tipWindow addSubview:self.tipView];</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    [<span class="keyword">self</span>.tipWindow addSubview:self.invertedTriangleView];</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    </div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    [<span class="keyword">self</span>.tipView configContentWithTip:tip];</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    [<span class="keyword">self</span>.invertedTriangleView setFrame:dotReact];</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    [<span class="keyword">self</span> initInvertedTriangle];</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    [<span class="keyword">self</span> setTipViewReactWithDirectionType:type dotReact:dotReact emptyReact:emptyReact];</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160; </div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keyword">self</span>.tipWindow.hidden = NO;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    [<span class="keyword">self</span> markEmptyViewInBg:emptyReact];</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="comment">// 给tipView 加事件</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    [<span class="keyword">self</span>.tipView addGestureRecognizer:self.tapGesture];</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;}</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160; </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;-(void)setTipViewReactWithDirectionType:(TriangleDirectionType)type dotReact:(CGRect)dotReact emptyReact:(CGRect)emptyReact</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;{</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    CGRect tipViewFrame = <span class="keyword">self</span>.tipView.frame;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    CGFloat <a class="code" href="category_u_i_view_07_x_h_x_rect_08.html#a102452aeb3a94e5600d5329cfe07fb97">x</a> = 0 ,<a class="code" href="category_u_i_view_07_x_h_x_rect_08.html#a7baea446235219eb6305623bf118fb15">y</a> = emptyReact.origin.y;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keywordflow">if</span> (type == TriangleDirectionType_Left) {</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <a class="code" href="category_u_i_view_07_x_h_x_rect_08.html#a102452aeb3a94e5600d5329cfe07fb97">x</a> = dotReact.origin.x + dotReact.<a class="code" href="category_u_i_view_07_x_h_x_rect_08.html#a75a449a894797f0a898194305575b6bc">size</a>.<a class="code" href="category_u_i_view_07_x_h_x_rect_08.html#a1b88998f3abbfef44bf36bba5f6eb6b4">width</a>;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    }<span class="keywordflow">else</span> <span class="keywordflow">if</span> (type == TriangleDirectionType_Right){</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        <a class="code" href="category_u_i_view_07_x_h_x_rect_08.html#a102452aeb3a94e5600d5329cfe07fb97">x</a> = dotReact.origin.x - tipViewFrame.<a class="code" href="category_u_i_view_07_x_h_x_rect_08.html#a75a449a894797f0a898194305575b6bc">size</a>.<a class="code" href="category_u_i_view_07_x_h_x_rect_08.html#a1b88998f3abbfef44bf36bba5f6eb6b4">width</a>;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    }</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    tipViewFrame.origin.x = <a class="code" href="category_u_i_view_07_x_h_x_rect_08.html#a102452aeb3a94e5600d5329cfe07fb97">x</a> ;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    tipViewFrame.origin.y = <a class="code" href="category_u_i_view_07_x_h_x_rect_08.html#a7baea446235219eb6305623bf118fb15">y</a> ;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keyword">self</span>.tipView.frame = tipViewFrame;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;}</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160; </div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="comment">//画三角形</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;- (void)initInvertedTriangle {</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    UIBezierPath *path = [UIBezierPath bezierPath];</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    [path moveToPoint:CGPointMake(0, 0)];</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    </div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    [<span class="keyword">self</span> drawTriangleWithPath:path];</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    CAShapeLayer *layer = [CAShapeLayer layer];</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    layer.fillColor = [UIColor colorWithHexString:@&quot;FF7235&quot;].CGColor;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    layer.path = path.CGPath;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    [<span class="keyword">self</span>.invertedTriangleView.layer addSublayer:layer];</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;}</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160; </div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;-(void)drawTriangleWithPath:(UIBezierPath *)path {</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <span class="keywordflow">if</span> (_triangleDirectionType == TriangleDirectionType_Left) {</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        [path addLineToPoint:CGPointMake(-7, 8)];</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        [path addLineToPoint:CGPointMake(0, 16)];</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    }<span class="keywordflow">else</span> <span class="keywordflow">if</span> (_triangleDirectionType == TriangleDirectionType_Right) {</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        [path addLineToPoint:CGPointMake(7, 8)];</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        [path addLineToPoint:CGPointMake(0, 16)];</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    }</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;}</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;- (void)markEmptyViewInBg:(CGRect)react {</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <span class="comment">// 创建一个全屏大的path</span></div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    UIBezierPath *path = [UIBezierPath bezierPathWithRect:[UIScreen mainScreen].bounds];</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="comment">// 创建一个矩形path</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    UIBezierPath *emptyPath = [[UIBezierPath bezierPathWithRect:react] bezierPathByReversingPath];</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    [path appendPath:emptyPath];</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    CAShapeLayer *shapeLayer = [CAShapeLayer layer];</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    shapeLayer.path = path.CGPath;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keyword">self</span>.bgView.layer.mask = shapeLayer;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    [_tipWindow layoutIfNeeded];</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;}</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160; </div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="preprocessor">#pragma mark - buttonEvent</span></div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;- (void)tipViewClicked:(<span class="keywordtype">id</span>)sender {</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    <span class="keywordflow">if</span> (_tipView) {</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        [_tipView removeGestureRecognizer:self.tapGesture];</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        [_tipView removeFromSuperview];</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        _tipView = nil;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        <span class="keyword">self</span>.tipWindow.hidden = YES;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    }</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160; </div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="keywordflow">if</span> ([<span class="keyword">self</span>.<a class="code" href="interface_beginner_tips_manager.html#a53d2f423aee4dc90ad3ce3fa4dfb53fe">delegate</a> respondsToSelector:<span class="keyword">@selector</span>(beginnerTipViewDismiss)]) {</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        [<span class="keyword">self</span>.delegate beginnerTipViewDismiss];</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    }</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;}</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160; </div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;<span class="preprocessor">#pragma mark - getter</span></div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;- (UIWindow *)tipWindow {</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keywordflow">if</span> (!_tipWindow) {</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        _tipWindow = [[UIWindow alloc] initWithFrame:[UIScreen mainScreen].bounds];</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        _tipWindow.rootViewController = [[UIViewController alloc] init];</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        _tipWindow.windowLevel = UIWindowLevelAlert;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        _tipWindow.backgroundColor = [UIColor clearColor];</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        [_tipWindow makeKeyAndVisible];</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    }</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keywordflow">return</span> _tipWindow;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;}</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160; </div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;- (UIView *)bgView{</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keywordflow">if</span> (!_bgView) {</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        _bgView = [[UIView alloc] initWithFrame:[UIScreen mainScreen].bounds];</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        _bgView.backgroundColor = [UIColor colorWithWhite:0 alpha:0.75];</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    }</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <span class="keywordflow">return</span> _bgView;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;}</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;- (<a class="code" href="interface_beginner_tips_view.html">BeginnerTipsView</a> *)tipView {</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <span class="keywordflow">if</span> (!_tipView) {</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        _tipView = [[<a class="code" href="interface_beginner_tips_view.html">BeginnerTipsView</a> alloc] initWithFrame:CGRectMake(0, 0, 233, 40)];</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        _tipView.userInteractionEnabled = YES;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    }</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    <span class="keywordflow">return</span> _tipView;</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;}</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; </div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;- (UIView *)invertedTriangleView {</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    <span class="keywordflow">if</span> (!_invertedTriangleView) {</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        _invertedTriangleView = [UIView new];</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        _invertedTriangleView.backgroundColor = [UIColor clearColor];</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    }</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <span class="keywordflow">return</span> _invertedTriangleView;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;}</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160; </div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160; </div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;- (UITapGestureRecognizer *)tapGesture {</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    <span class="keywordflow">if</span> (!_tapGesture) {</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        _tapGesture = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(tipViewClicked:)];</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    }</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    <span class="keywordflow">return</span> _tapGesture;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;}</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160; </div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160; </div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160; </div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;<span class="keyword">@end</span></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="acategory_u_i_view_07_x_h_x_rect_08_html_a1b88998f3abbfef44bf36bba5f6eb6b4"><div class="ttname"><a href="category_u_i_view_07_x_h_x_rect_08.html#a1b88998f3abbfef44bf36bba5f6eb6b4">UIView(XHXRect)::width</a></div><div class="ttdeci">CGFloat width</div><div class="ttdef"><b>Definition:</b> <a href="_u_i_view_09_x_h_x_rect_8h_source.html#l00019">UIView+XHXRect.h:19</a></div></div>
<div class="ttc" id="a_beginner_tips_view_8h_html"><div class="ttname"><a href="_beginner_tips_view_8h.html">BeginnerTipsView.h</a></div></div>
<div class="ttc" id="ainterface_beginner_tips_manager_html_a53d2f423aee4dc90ad3ce3fa4dfb53fe"><div class="ttname"><a href="interface_beginner_tips_manager.html#a53d2f423aee4dc90ad3ce3fa4dfb53fe">BeginnerTipsManager::delegate</a></div><div class="ttdeci">id&lt; BeginnerTipsManagerDelegate &gt; delegate</div><div class="ttdef"><b>Definition:</b> <a href="_beginner_tips_manager_8h_source.html#l00025">BeginnerTipsManager.h:25</a></div></div>
<div class="ttc" id="acategory_u_i_view_07_x_h_x_rect_08_html_a75a449a894797f0a898194305575b6bc"><div class="ttname"><a href="category_u_i_view_07_x_h_x_rect_08.html#a75a449a894797f0a898194305575b6bc">UIView(XHXRect)::size</a></div><div class="ttdeci">CGSize size</div><div class="ttdef"><b>Definition:</b> <a href="_u_i_view_09_x_h_x_rect_8h_source.html#l00010">UIView+XHXRect.h:10</a></div></div>
<div class="ttc" id="ainterface_beginner_tips_view_html"><div class="ttname"><a href="interface_beginner_tips_view.html">BeginnerTipsView</a></div><div class="ttdef"><b>Definition:</b> <a href="_beginner_tips_view_8h_source.html#l00012">BeginnerTipsView.h:13</a></div></div>
<div class="ttc" id="a_beginner_tips_manager_8h_html"><div class="ttname"><a href="_beginner_tips_manager_8h.html">BeginnerTipsManager.h</a></div></div>
<div class="ttc" id="ainterface_beginner_tips_manager_html"><div class="ttname"><a href="interface_beginner_tips_manager.html">BeginnerTipsManager</a></div><div class="ttdef"><b>Definition:</b> <a href="_beginner_tips_manager_8h_source.html#l00023">BeginnerTipsManager.h:24</a></div></div>
<div class="ttc" id="a_u_i_color_09_hex_8h_html"><div class="ttname"><a href="_u_i_color_09_hex_8h.html">UIColor+Hex.h</a></div></div>
<div class="ttc" id="acategory_u_i_view_07_x_h_x_rect_08_html_a7baea446235219eb6305623bf118fb15"><div class="ttname"><a href="category_u_i_view_07_x_h_x_rect_08.html#a7baea446235219eb6305623bf118fb15">UIView(XHXRect)::y</a></div><div class="ttdeci">CGFloat y</div><div class="ttdef"><b>Definition:</b> <a href="_u_i_view_09_x_h_x_rect_8h_source.html#l00018">UIView+XHXRect.h:18</a></div></div>
<div class="ttc" id="acategory_u_i_view_07_x_h_x_rect_08_html_a102452aeb3a94e5600d5329cfe07fb97"><div class="ttname"><a href="category_u_i_view_07_x_h_x_rect_08.html#a102452aeb3a94e5600d5329cfe07fb97">UIView(XHXRect)::x</a></div><div class="ttdeci">CGFloat x</div><div class="ttdef"><b>Definition:</b> <a href="_u_i_view_09_x_h_x_rect_8h_source.html#l00017">UIView+XHXRect.h:17</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_05f730b1f29a3e373a3d04cb5cb42ea7.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_2d533305e802e0a7e844b4ecd2e2bdb2.html">Classes</a></li><li class="navelem"><a class="el" href="dir_0feec6aa4a794b404f9caa810216c37c.html">BeginnerTipsManager</a></li><li class="navelem"><a class="el" href="_beginner_tips_manager_8m.html">BeginnerTipsManager.m</a></li>
    <li class="footer">制作者
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.18 </li>
  </ul>
</div>
</body>
</html>
